// runapp.c

#include <windows.h>
#include <winsvc.h>
#include "wdjsrvc.h"

TCHAR szAppName[] = TEXT("RunApp");
HINSTANCE hInst;
HANDLE hLogOn, hLogOff;
SC_HANDLE hSCManager, hService;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, 
                         LPARAM lParam)
{
    SERVICE_STATUS ss;
    
    switch (message) {

        case WM_CREATE:
            SetEvent(hLogOn);          
            ControlService(hService,WDJSRVC_CONTROL_LOGON,&ss);    
            break;

        case WM_QUERYENDSESSION:
            // process this message if needed
            return TRUE;

        case WM_ENDSESSION:
            SetEvent(hLogOff);
            ControlService(hService,WDJSRVC_CONTROL_LOGOFF,&ss);    
            return TRUE;

        case WM_DESTROY:            
            CloseHandle(hLogOn);
            CloseHandle(hLogOff);
            CloseServiceHandle(hService);
            CloseServiceHandle(hSCManager);
            PostQuitMessage(0);
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
    MSG       msg;
    WNDCLASS  wc;
    HWND      hWnd;

    hInst = hInstance;
    
    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = NULL;
    wc.hCursor       = NULL;
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = szAppName;
    RegisterClass(&wc);
    
    hLogOn = CreateEvent(NULL,FALSE,FALSE,WDJSRVC_LOGON_EVENT);
    hLogOff = CreateEvent(NULL,FALSE,FALSE,WDJSRVC_LOGOFF_EVENT); 

    hSCManager = OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
    hService = OpenService(hSCManager, WDJSRVC_NAME, 
                           SERVICE_USER_DEFINED_CONTROL);
    
    hWnd = CreateWindow(szAppName, NULL, WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                        NULL, NULL, hInstance, NULL);
    
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
   }

   return msg.wParam;
}

